/*
    FEARLUS model0-6-2: LandManagerHistory.m
    Copyright (C) 1999-2002  Macaulay Institute
    Copyright (C) 1999-2002  Macaulay Institute
    Copyright (C) 1999-2002  Macaulay Institute

    This file is part of FEARLUS model0-6-2, an agent-based model of land use
    change.

    FEARLUS model0-6-2 is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FEARLUS model0-6-2 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/
/*


Interface for the LandManagerHistory class.

*/

#import "LandManagerHistory.h"

@implementation LandManagerHistory

/*

initialiseWithYear

Record all the information required for a single year

*/

-(void)initialiseWithYear: (unsigned)yr
	landParcelsGained: (int)lpg
      neighbourhoodWeight: (double)s
		     barn: (double)b // wealth
		      age: (unsigned)a {
  year = yr;
  parcelsGained = lpg;
  neighbourhoodWeight = s;
  barn = b;			// wealth
  age = a;
}

/*

printToFile

Write a year's data to the file

*/

-(void)printToFile: (FILE *)fp {
  fprintf(fp, "%u\t%d\t%u\t%g\t%g", year, parcelsGained,
	  age, barn, neighbourhoodWeight); // wealth
}

@end
